Attribute VB_Name = "Module1"
Private Declare Function GetObjectA Lib "gdi32" (ByVal hObject As Long, ByVal nCount As Long, ByRef lpObject As Any) As Long

Global PrgRun As Boolean 'Flag = Programm luft

Public Texture(15) As GLuint 'Handle der Texturen
Public DisplayLists(1) As GLuint 'Handle der Displaylisten
Public Disp As Boolean 'Darstellung ber Displayliste Ein/Aus

Private hrc As Long 'Handle fr den OpenGL Gertekontext

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type TpVertex 'Vertex-Struktur
   X As GLfloat 'X-Koordinate
   Y As GLfloat 'Y-Koordinate
   Z As GLfloat 'Z-Koordinate
   U As GLfloat 'U-Koordinate (Textur)
   V As GLfloat 'V-Koordinate (Textur)
End Type

Private Type TpTriangle 'Dreieck-Struktur
   Vertex(2) As TpVertex  'Array mit 3 Punkten
   T As Integer 'Index der verwendeten Textur
End Type

Private Type TpSector 'Sektor-Struktur
   Sct_NummTriangle As Integer 'Anzahl der Dreiecke im Sektor
   Triangle() As TpTriangle 'Zeiger auf ein Array mit Dreiecken
End Type

Private Sektor(0) As TpSector 'Array fr einen Sektor

Public Sub LoadTexture(ByVal Filename As String, ByVal Index As Long)
   Dim bmp As BITMAP
   'Vorraussetzungen:
   'Die Grafik mu quadratisch sein!
   'Die Seitenlnge der Grafiken mssen 2er Potenzen entsprechen:
   '16,32,64,128,256,512,1024 Pixel etc.
   'Durch den Umweg ber die Picturebox sind aber auch Formate wie jpg oder gif mglich.
   'Die Autosize-Eigenschaft der Picturebox mu auf True stehen!
   
   Form1.Picture1.Picture = LoadPicture(Filename) 'Bild laden
   
   'GetObjectA gibt Informationen ber die im Aufruf bermittelte Bitmap der
   'Picturebox zurck und speichert diese in der bmp-Struktur.
   'Es wird also eine Bitmap aus den Daten der Picturebox im Speicher erstellt.
   If GetObjectA(Form1.Picture1.Picture.Handle, LenB(bmp), bmp) Then
        glGenTextures 1, Texture(Index)  'kreiert eine Textur
        glBindTexture glTexture2D, Texture(Index) 'Zuweisung: die Textur ist 2D
        'Generieren der eigentlichen Texture in OpenGL
        glTexImage2D glTexture2D, 0, 3, bmp.bmWidth, bmp.bmHeight, 0, tiBGRExt, GL_UNSIGNED_BYTE, ByVal bmp.bmBits
        'Der 1. Parameter besagt wieder 2D Textur
        'Der 2. Parameter gibt den Grad der Details an, ist aber vorerst einmal unwichtig
        'Der 3. Parameter gibt die Art der Farbkanle an, 3 = RGB.
        'Parameter 4 und 5 sind Breite und Hhe der Textur
        'Der 6. Parameter gibt die Rahmenbreite an, vorerst aber mal 0.
        'Parameter 7 und 8 geben Farbformat (RGB) und Art der Daten (Unsigned Byte = 0 - 255) an.
        'Der letzte Parameter bergibt schluendlich die eigentliche Textur.
        
        'Diese Zeilen legen fest, welcher Filter verwendet werden soll:
        glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
        glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
        'tpnTextureMinFilter besagt, mit welchem Filter die Grafik zusammengedrckt werden soll.
        'tpnTextureMagFilter besagt, mit welchem Filter die Grafik auseinandergezogen wird.
        'Der Parameter GL_LINEAR erzeugt das beste Ergebnis, belastet aber den Prozessor.
        'Mglich wre auch GL_NEAREST. Das entlastet zwar die Hardware, sieht aber schnell recht pixelig aus.
        LoadTexturePic = True
   End If
End Sub

Public Sub GenerateLists()
   DisplayLists(0) = glGenLists(1) 'Zeiger auf eine neue Displayliste
   glNewList DisplayLists(0), lstCompile 'Neue Displayliste beginnen.
   'Der Parameter lstCompile weist OpenGL an, die Liste sofort zu kompilieren.
      Call DrawScene 'Zeichnen der Szene
   glEndList 'fertig
End Sub

Public Sub Main()
   Static r4eckY As GLfloat 'Winkel der Y-Achse fr das Viereck
   Dim I As Integer, J As Integer 'Zhlvariablen
   Dim frm As Form
   PrgRun = True 'Flag = das Programm luft
   Set frm = New Form1 'Fenster fr OpenGL-Ausgabe
   frm.ScaleMode = vbPixels 'das Fenster mu zwingend in Pixel bemessen werden

   If CreateGLWindow(frm, 640, 480, 16) Then 'Fenster initialisieren
      
      Do 'Endlosschleife in der das Fenster laufend gelscht und neu aufgebaut wird.
         'Die Laufzeit dieser Schleife ist ausschlaggebend, wieviele Objekt gezeichnet werden knnen
         T1 = Timer 'Zeitpunkt Beginn der Darstellung
         glClear clrColorBufferBit Or clrDepthBufferBit ' lscht das Fenster und den Tiefenpuffer
         glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
         glTranslatef 0#, 0#, -8#
         glRotatef r4eckY, 0#, 1#, 0# 'Drehen des Wrfels um die Y Achse
         
         If Disp Then
            glCallList DisplayLists(0) 'Darstellung ber Displayliste
         Else
            Call DrawScene 'direktes Zeichnen
         End If
         
         SwapBuffers (frm.hDC) 'Puffer tauschen (Double Buffering)
         DoEvents
      
         r4eckY = r4eckY + 0.2 'Winkel fr Drehung hochzhlen
         
         T2 = Timer 'Zeitpunkt Ende der Darstellung
         Ct = Ct + 1 'Zhler fr Frames
         Fps = Fps + (T2 - T1) 'Verbrauchte Zeit hochzhlen
         If Fps > 1 Then 'nach einer Sekunde ausgeben
            If Disp Then
               frm.Caption = Ct & " Frames/Sec mit Displayliste"
            Else
               frm.Caption = Ct & " Frames/Sec bei direktem Zeichnen"
            End If
            Fps = Fps - 1
            Ct = 0
         End If
      Loop While PrgRun 'Programm nur beenden, wenn PrgRun = False
      'PrgRun ist Global definiert und wird im KeyDown-Ereignis von Form1 bei drcken von Escape gesetzt.
      
      'alles freigeben und Programm beenden
      If hrc <> 0 Then 'hatten wir einen Gertekontext fr OpenGL?
         wglMakeCurrent 0, 0 'Freigeben des Gertekontexts
         wglDeleteContext (hrc) 'Freigeben des Renderingkontexts
      End If
      Unload frm
      Set frm = Nothing
      End
   End If
End Sub

Public Function CreateGLWindow(frm As Form, Width As Integer, Height As Integer, Bits As Integer) As Boolean
   Dim Mt_Diffuse(3) As GLfloat 'Material fr diffuses Licht
   Dim Mt_Ambient(3) As GLfloat 'Material fr Umgebungslicht
   Dim Mt_Specular(3) As GLfloat 'Material fr gespiegeltes Licht
   Dim Mt_Shiness(0) As GLfloat 'Glanz des Materials
   
   Dim Lt_Position(3) As GLfloat 'Position der Lichtquelle
   Dim Lt_Diffuse(3) As GLfloat 'diffuses Licht
   Dim Lt_Ambient(3) As GLfloat 'Umgebungslicht
   Dim Lt_Specular(3) As GLfloat 'Spotlicht / Glanzlicht
   
   'Position der Lichtquelle
   'auf der Z-Achse als positiver Wert = 10 Einheiten vor dem Bildschirm
   Lt_Position(0) = 0#: Lt_Position(1) = 0#: Lt_Position(2) = 0#: Lt_Position(3) = 1#
   
   'Materialeigenschaft fr diffuses Licht
   Mt_Diffuse(0) = 0.8: Mt_Diffuse(1) = 0.8: Mt_Diffuse(2) = 0.8: Mt_Diffuse(3) = 1#
   
   'Materialeigenschaft fr Umgebungslicht
   Mt_Ambient(0) = 0.3: Mt_Ambient(1) = 0.3: Mt_Ambient(2) = 0.3: Mt_Ambient(3) = 1#
   
   'Materialeigenschaft fr Glanz
   Mt_Specular(0) = 1: Mt_Specular(1) = 1: Mt_Specular(2) = 1: Mt_Specular(3) = 1
   
   'Exponent fr Glanz
   Mt_Shiness(0) = 50#
   
   'Lichtstrke/farbe fr Umgebungslicht
   Lt_Ambient(0) = 0.2: Lt_Ambient(1) = 0.2: Lt_Ambient(2) = 0.2: Lt_Ambient(3) = 1#
   
   'Lichtstrke/farbe fr diffuses Licht
   Lt_Diffuse(0) = 0.5: Lt_Diffuse(1) = 0.5: Lt_Diffuse(2) = 0.5: Lt_Diffuse(3) = 0.5
   
   'Lichtstrke/farbe fr Spot (Glanz)
   Lt_Specular(0) = 1: Lt_Specular(1) = 1: Lt_Specular(2) = 1: Lt_Specular(3) = 1
   
   Dim pfd As PIXELFORMATDESCRIPTOR ' pfd erklrt Windows, wie das Fenster beschaffen sein soll
   Dim PixelFormat As GLuint ' enthlt das Ergebnis vom Versuch, ein Fenster mit den gegebenen Parametern zu erstellen
      
   pfd.cColorBits = Bits 'Farbtiefe
   pfd.cDepthBits = 16 '16 Bit Tiefenpuffer
   'Der Tiefenpuffer enthlt die Entfernung eines Pixels zur Kamera (Betrachter).
   'Er verhindert, da Objekte im Hintergrund beim Zeichnen Objekte im Vordergund berlagern.
   pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
   'PFD_DRAW_TO_WINDOW = das Format mu als Fenster sichtbar sein knnen
   'PFD_SUPPORT_OPENGL = das Format mu OpenGL untersttzen
   'PFD_DOUBLEBUFFER = das Foramt mu Double Buffering untersttzen
   pfd.iLayerType = PFD_MAIN_PLANE 'Die Hauptebene auf der gezeichnt wird.
   pfd.iPixelType = PFD_TYPE_RGBA 'Pixel werden im RGBA Modus dargestellt.
   'RGB ist mit VB identisch. Fr A wird ein Alpha-Wert fr die Transparenz bergeben
   pfd.nSize = Len(pfd) 'Gre der Struktur sollte natrlich stimmen
   pfd.nVersion = 1 'Versionsnummer

   PixelFormat = ChoosePixelFormat(frm.hDC, pfd) 'Windows nach einem oben beschriebenen Pixelformat fragen
   If PixelFormat <> 0 Then
      'Windows hat ein entsprechendes Format gefunden
      If SetPixelFormat(frm.hDC, PixelFormat, pfd) <> 0 Then
         'Einrichten des Pixelformates war erfolgreich
         hrc = wglCreateContext(frm.hDC)
         If hrc <> 0 Then
            'ein Rendering Kontext wurde erstellt
            If wglMakeCurrent(frm.hDC, hrc) <> 0 Then
               'Der Kontext wurde aktiviert
               frm.Show 'Fenster anzeigen
               Call LoadTexture(App.Path & "\holz.jpg", 1) 'laden und erzeugen eines Textures
               glEnable glcTexture2D 'Einschalten des Texture Mappings
               glShadeModel smSmooth 'schaltet schne Farbbergange ein
               glClearColor 0#, 0#, 0#, 0.5  'schwarzer Hintergrund
               glClearDepth 1# 'Tiefenpuffer zurcksetzten (spter mehr)
               glEnable glcDepthTest 'Aktivierung des Tiefentests (spter mehr)
               glDepthFunc cfLEqual 'Typ des Tiefentests (spter mehr)
               glHint htPerspectiveCorrectionHint, hmNicest 'Art der Perspectivenansicht
               'hmNicest = beste Ansicht / hmFastest = schnellste Darstellung
         
               glMaterialfv GL_FRONT, GL_SPECULAR, Mt_Specular(0) 'Materialeigenschaft fr Specular setzen
               glMaterialfv GL_FRONT, GL_SHININESS, Mt_Shiness(0) 'Exponent fr den Glanz
               glMaterialfv GL_FRONT, GL_DIFFUSE, Mt_Diffuse(0) 'Materialeigenschaft fr Diffus setzen
               glMaterialfv GL_FRONT, GL_AMBIENT, Mt_Ambient(0) 'Materialeigenschaft fr Ambient setzen
               glLightfv GL_LIGHT1, GL_DIFFUSE, Lt_Diffuse(0) 'diffuses Licht setzen
               glLightfv GL_LIGHT1, GL_AMBIENT, Lt_Ambient(0) 'Umgebungslicht setzen
               glLightfv GL_LIGHT1, GL_SPECULAR, Lt_Specular(0) 'Glanzlicht setzen
               glLightfv GL_LIGHT1, GL_POSITION, Lt_Position(0) 'Position der Lampe setzen
               
               glEnable GL_LIGHTING 'Licht einschalten.
               glEnable GL_LIGHT1 'Licht Nr. 1 einschalten.
               glEnable GL_COLOR_MATERIAL 'Farben unter Textur aktivieren
               LoadWorld App.Path & "\Kugel.txt" 'einlesen der Welt-Daten
               Call GenerateLists 'Displaylisten erstellen
               CreateGLWindow = True
            End If
         End If
      End If
   End If
End Function

Public Sub ReSizeGLScene(ByVal Width As GLsizei, ByVal Height As GLsizei)
   'Anpassen der Gre und Initialisierung des OpenGL-Fensters
   If Height = 0 Then 'Die Fensterhhe mu grer 0 sein
       Height = 1 'sonst kommt es zu einem Division by Zero Fehler
   End If
   glViewport 0, 0, Width, Height 'leeren des aktuellen Viewports
   glMatrixMode mmProjection 'Auswahl der Projektionsmatrix
   glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck

   gluPerspective 45#, Width / Height, 0.1, 100# 'Berechnung des aktuellen Seitenverhltnisses des Fensters

   glMatrixMode mmModelView 'Auswahl der Modelview Projektionsmatrix
   glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
End Sub



Public Sub LoadWorld(File As String)
   Dim I, J As Integer 'Zhlvariablen
   Dim F As Long 'Dateinummer
   Dim Zeile As String 'Einzelzeile aus der Datei
   Dim Segment() As String 'einzelne Anweisung / Koordinate in der Zeile
   Dim AnzDreieck As Integer 'Anzahl der Dreiecke in der Datei
   
   'Datei ffnen
   F = FreeFile
   Open File For Input Shared As #F
   
   '1. Zeile lesen
   Line Input #F, Zeile
   Segment = Split(Zeile, " ") 'Space als Trennzeichen
   'hier in der 1. Zeile die Anzahl der Dreiecke
   If Segment(0) = "NUMTRIANGLES" Then
      AnzDreieck = Val(Segment(1))
      ReDim Sektor(0).Triangle(AnzDreieck) 'Speicher fr Dreieck-Koordinaten
      Sektor(0).Sct_NummTriangle = AnzDreieck 'Anzahl der Dreiecke ablegen
      I = 0
      J = 0
      Do 'Alle Dreiecke einlesen
         Line Input #F, Zeile 'Zeile lesen
         Zeile = Trim(Zeile) 'fhrende Spaces abschneiden
         'Leere Zeilen und Kommentare (beginnen mit /) ignorieren
         If Len(Zeile) > 0 And Left(Zeile, 1) <> "/" Then
             Do
                Zeile = Replace(Zeile, "  ", " ") 'entfernen mehrfacher Spaces
             Loop Until InStr(1, Zeile, "  ") = 0
             If J < 3 Then
                Segment = Split(Zeile, " ") 'in Punkte zerlegen
                'Punkte fr Dreieck und Texturen in Struktur speichern
                Sektor(0).Triangle(I).Vertex(J).X = Val(Segment(0))
                Sektor(0).Triangle(I).Vertex(J).Y = Val(Segment(1))
                Sektor(0).Triangle(I).Vertex(J).Z = Val(Segment(2))
                Sektor(0).Triangle(I).Vertex(J).U = Val(Segment(3))
                Sektor(0).Triangle(I).Vertex(J).V = Val(Segment(4))
                J = J + 1
             Else
                Sektor(0).Triangle(I).T = Val(Trim(Zeile)) 'Texturindex merken
                J = 0 'Punktezhler zurcksetzen
                I = I + 1 'nchstes Dreieck
             End If
         End If
      Loop Until I >= AnzDreieck
   End If
End Sub


Public Sub DrawScene()
   'Darstellung der eingelesenen Daten in einer Schleife
   For I = 0 To Sektor(0).Sct_NummTriangle - 1 'alle Dreiecke abarbeiten
       'Auswahl der gewnschten Textur
       If Sektor(0).Triangle(I).T > 0 Then glBindTexture GL_TEXTURE_2D, Texture(Sektor(0).Triangle(I).T)
       glBegin bmTriangles
          For J = 0 To 2 '3 Punkte je Dreieck
              With Sektor(0).Triangle(I).Vertex(J)
                 glTexCoord2f .U, .V: glVertex3f .X, .Y, .Z
              End With
          Next
       glEnd
   Next
End Sub
